/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var rzpOptions = {
    key: "rzp_test_1DP5mmOlF5G5ag",
    amount: "2000", // 2000 paise = INR 20
    name: "Merchant Name",
    description: "Purchase Description",
    image: "https://i.imgur.com/n5tjHFD.png",
    handler: function (response){
        alert(response.razorpay_payment_id);
    },
    prefill: {
        name: "Harshil Mathur",
        email: "harshil@razorpay.com"
    },
    notes: {
        address: "Hello World"
    },
    theme: {
        color: "#F37254"
    }
};

var successCallback = function(payment_id) {
  alert('payment_id: ' + payment_id)
};

var cancelCallback = function(error) {
  alert(error.description + ' (Error '+error.code+')')
};

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.addRZPEventListener();       
    },

    addRZPEventListener: function() {
        try{
            document.getElementById('rzp-button').addEventListener('click', function(event) {
                RazorpayCheckout.open(rzpOptions, successCallback, cancelCallback);
                event.preventDefault();
            })
        }
        catch(err){

        }
    }

   

};

app.initialize();


/*************************************************************Facebook Work Starts ***************************************************************/
function fbLoginSuccess (response) {
    if (!response.authResponse) {
        fbLoginError("Cannot find the AuthResponse");
        return;
    }

    var authResponse = response.authResponse;
    getFacebookProfileInfo(authResponse)
}


//This is the fail callback from the login method
function fbLoginError(error) {
   alert("fbLoginError : " + JSON.stringify(obj))
}

//this method is to get the user profile info from the facebook api
function getFacebookProfileInfo (authResponse) {
    try {
        facebookConnectPlugin.api(authResponse.userID + "/?fields=id,email,first_name,last_name,link,gender,name", ["public_profile"],
		function(result) {
			alert(JSON.stringify(result));                        
		},
		function(error) {
			alert("Failed: " + error);
		});
    } catch (ex) { alert("Error while Facebook Login " + ex)}
}

//This method is executed when the user press the "Login with facebook" button
function facebookSignIn() {
	try {
    facebookConnectPlugin.getLoginStatus(function (success) {
        if (success.status === 'connected') {
            getFacebookProfileInfo(success.authResponse);
        } else {
            facebookConnectPlugin.login(['email', 'public_profile'], fbLoginSuccess, fbLoginError);
        }
    });
    } 
	catch (ex) { alert("Error" + ex)}
}


